>From a74262dfa5d9f1b437d66bf1cc969bf3dcc52117 Mon Sep 17 00:00:00 2001
From: Thibaut Girka <thib@sitedethib.com>
Date: Thu, 26 Apr 2012 23:08:14 +0200
Subject: [PATCH 2/2] Add support for specific arch qualifiers and cross-arch
 dependencies

---
 lib/dpkg/fields.c    |    2 --
 scripts/Dpkg/Deps.pm |    5 ++++-
 2 files changed, 4 insertions(+), 3 deletions(-)

diff --git a/lib/dpkg/fields.c b/lib/dpkg/fields.c
index ed655f9..07091d2 100644
--- a/lib/dpkg/fields.c
+++ b/lib/dpkg/fields.c
@@ -448,8 +448,6 @@ f_dependency(struct pkginfo *pkg, struct pkgbin *pkgbin,
 
         if (dop->arch->type == arch_illegal)
           emsg = dpkg_arch_name_is_illegal(arch.buf);
-        else if (dop->arch->type != arch_wildcard)
-          emsg = _("a value different from 'any' is currently not allowed");
         if (emsg)
           parse_error(ps, _("'%s' field, reference to '%.255s': "
                             "invalid architecture name '%.255s': %s"),
diff --git a/scripts/Dpkg/Deps.pm b/scripts/Dpkg/Deps.pm
index d85ad5f..89cbbfa 100644
--- a/scripts/Dpkg/Deps.pm
+++ b/scripts/Dpkg/Deps.pm
@@ -575,7 +575,7 @@ sub parse_string {
               ([a-zA-Z0-9][a-zA-Z0-9+.-]*)  # package name
               (?:                           # start of optional part
                 :                           # colon for architecture
-                (any|native)                # architecture name
+                ([a-zA-Z0-9][a-zA-Z0-9-]*)  # architecture name
               )?                            # end of optional part
               (?:                           # start of optional part
                 \s* \(                      # open parenthesis for version part
@@ -1275,6 +1275,9 @@ sub _find_package {
 	    return $p if $ma eq "allowed";
 	} elsif ($archqual eq "native") {
 	    return $p if $a eq $build_arch and $ma ne "foreign";
+	} else
+	{
+	    return $p if $a eq $archqual;
 	}
     }
     return undef;
-- 
1.7.10

